/* -------------------- main_cli.c -----------------------
 * client using TCP protocol
 */

#include "inet.h"
#include "proto.h"

int main(){
   int sockfd;
   struct sockaddr_in serv_addr;

   /*
    * fill in the structure "serv_addr" with address
    * of server we want to connect with
    */

   bzero( (char *) &serv_addr, sizeof(serv_addr));
   serv_addr.sin_family = AF_INET;
   serv_addr.sin_addr.s_addr = inet_addr(SERV_HOST_ADDR);
   serv_addr.sin_port = htons(SERV_TCP_PORT);

   /*
    * open a TCP socket - internet stream socket
    */
   
   if ( (sockfd = socket(AF_INET, SOCK_STREAM,0)) < 0 ) {
      perror("client: can't open stream socket");
      exit(2);
   }

   /*
    * connect to the server
    */

   if (connect(sockfd, (struct sockaddr *) &serv_addr,
         sizeof(serv_addr) ) < 0) {
      perror("client: can't connect to server");
      exit(3);
   }

   /**************************/
   {
      proto_req req;
      proto_ans ans;

      printf("a op b: ");
      fscanf(stdin, "%d %c %d", &req.a, &req.op, &req.b);

      req.a = htonl(req.a);
      req.b = htonl(req.b);

      if (send(sockfd, &req, sizeof(req), 0) < sizeof(req)) {
	 perror("send");
	 exit(1);
      }

      if (recv(sockfd, &ans, sizeof(ans), 0) < sizeof(ans)) {
	 perror("recv");
	 exit(2);
      }

      if (ans.is_error)
	 fprintf(stderr, "Error: %s\n", ans.error);
      else
         printf("a %c b = %d\n", req.op, ntohl(ans.erg));
   }
   /**************************/

   exit(0);
}
