/* -------------------- main_cli.c -----------------------
 * client using TCP protocol
 */

#include "inet.h"
#include "ipc_send.h"
#include "ipc_recv.h"

int main(){
   int sockfd;
   struct sockaddr_in serv_addr;

   /*
    * fill in the structure "serv_addr" with address
    * of server we want to connect with
    */

   bzero( (char *) &serv_addr, sizeof(serv_addr));
   serv_addr.sin_family = AF_INET;
   serv_addr.sin_addr.s_addr = inet_addr(SERV_HOST_ADDR);
   serv_addr.sin_port = htons(SERV_TCP_PORT);

   /*
    * open a TCP socket - internet stream socket
    */
   
   if ( (sockfd = socket(AF_INET, SOCK_STREAM,0)) < 0 ) {
      perror("client: can't open stream socket");
      exit(2);
   }

   /*
    * connect to the server
    */

   if (connect(sockfd, (struct sockaddr *) &serv_addr,
         sizeof(serv_addr) ) < 0) {
      perror("client: can't connect to server");
      exit(3);
   }

   /**************************/
   {
      int a, b;
      char op;
      char buf[1024];

      printf("a op b: ");
      fscanf(stdin, "%d %c %d", &a, &op, &b);

      sprintf(buf, "%c %d %d\n", op, a, b);

      if (sendn(sockfd, buf, strlen(buf)) < strlen(buf)) {
	 perror("sendn");
	 exit(1);
      }

      if (recvn(sockfd, buf, sizeof(buf)) <= 0) {
	 perror("recvn");
	 exit(2);
      }

      if (buf[0] != '+') {
	 fprintf(stderr, "Error: %s", buf+1);
	 exit(1);
      }
      else
	 printf("a %c b = %s", op, buf+1);
   }
   /**************************/

   exit(0);
}
